#include "Population.h"
#include <random>
#include <iostream>
using namespace std;

// Default constructor
// Default population size is a random int up to defaultMaxSize
// Sets mean age
Population::Population()
{
	// Similar to default Individual constructor but here
	// create a set of Individuals such that Population size
	// is random up to a max of defaultMaxSize

	// Remember to set the mean age of the Population (what is it?)
}

// Constructor with specified population size
// Sets mean age
Population::Population(int _size)
{
	// Create a set of _size Individuals in for this Population

	// Remember to set the mean age of the Population (what is it?)
}

// Destructor
// Not particularly useful in this particular <vector>-based implementation
// REQUIRED FOR ARRAY-BASED IMPLEMENTATIONS!
Population::~Population()
{
}

// Termination condition checks for Ackley function solution
// Equality comparison with doubles is not straightforward (COEN243)
bool Population::solutionExists(double _tolerance)
{
	// This is the termination condition.
	// What is the solution to the Ackley function (see paper)?
	// IF THAT SOLUTION EXISTS then the termination condition has been
	// met.
	// Remember from earlier programming courses that it isn't a good
	// idea to simply check if two doubles are equal due to the way
	// floating-point numbers are represented in computers.
}

// returns population size
int Population::getSize()
{
	return population.size();
}

// returns average age in generations
double Population::getMeanAge()
{
	return meanAge;
}


Population& Population::operator!()
{
	// Mutates every member of the population, i.e.
	// FOR (EVERY MEMBER OF POPULATION) MUTATE.
	// Don't implement Individual mutation here but
	// remember that the average age will change.
	// Return handle to mutated population in case it is needed
	// somewhere.
}


// Print the Population to the screen
// THIS BECOMES VERY LONG IF LARGE POPULATIONS ARE USED
void Population::printPop()
{
	int size = getSize();
	for(int i = 0; i < size; i++)
		population[i].printInd();
	cout << endl;
}

// mutate a target Individual
/* Mutation is performed by the "environment"
** not by an Individual itself.
** Since the environment needs access to an
** the Individual's genotype, a friend
** declaration was used. */
// return the target after mutating
Individual& operator!(Individual& target)
{


	// The required inputs for a mutation are a probability of mutation and
	// the Individual's genotype.  For each cell in the Individual's genotype
	// mutate IFF the condition is met.

	// Generate a random double
	// The condition to mutate a cell value is met if the random double
	// is less than or equal to the probability of mutation.
	// E.g., if probability of mutation is 90% then any random double
	// from 0.0 to 0.9 (i.e. 90% of values) will allow mutation but
	// nothing greater than 0.9 (i.e. 10% of values) will allow mutation.
		
	// If the condition is met, the cell will be mutated.
	// Mutation is implemented using a normal distribution such
	// that mean = cell value and standard deviation = percentage
	// of cell value.
			
	// No cell's value can be less than -32.768 or greater
	// than 32.768.  Any cell values between these (inclusive)
	// are acceptable.
	
	// Fitness changes when mutated and should be updated

	// The Individual is "older" once it has been mutated
	
	// Return a handle to the mutated target in case it is needed somewhere
}