#include "Individual.h"
#include "Population.h"
#include <iostream>
#include <cstdlib>
#include <ctime>

using namespace std;

void main()
{
	srand(time(NULL));
	int numGenerations = 0;

	// Pre-loop
	Population myPopulation;
	cout << endl << "Population created with " << myPopulation.getSize() << " Individuals." << endl;

	cout << "How many times should the population be mutated? ";
	cin >> numGenerations;

	cout << endl << endl << "Press Enter to begin the mini-loop." << endl;
	getchar();

	// Mini-loop
	while(!myPopulation.solutionExists() && myPopulation.getMeanAge() < numGenerations)
	{
		cout << endl << "Generation: " << myPopulation.getMeanAge();
		!myPopulation;
		cout << endl;
	}

	// After exiting loop
	if(myPopulation.solutionExists())
	{
		cout << endl << "Solution found in Generation: " << myPopulation.getMeanAge();
		cout << endl << "Solution is: ";

		cout << endl;
	}
	else
		cout << endl << "No solution found after " << numGenerations << " mutations." << endl;

	system("PAUSE");
}